"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
require("reflect-metadata");
const deprecate_1 = require("../maintenance/deprecate");
function createSetupTeardownDecorator(metadataDescription, isAsync) {
    return (target, decoratedPropertyKey, descriptor) => {
        const functions = Reflect.getMetadata(metadataDescription, target) || [];
        const functionName = metadataDescription
            .replace("alsatian:", "")
            .replace("-fixture", "Fixture")
            .replace("setup", "Setup")
            .replace("teardown", "Teardown");
        deprecate_1.deprecate(isAsync ? `Async${functionName}` : functionName, "4.0.0", `Use the ${functionName.replace("Fixture", "")} decorator instead.`);
        functions.push({
            isAsync,
            propertyKey: decoratedPropertyKey
        });
        Reflect.defineMetadata(metadataDescription, functions, target);
    };
}
exports.createSetupTeardownDecorator = createSetupTeardownDecorator;
//# sourceMappingURL=create-setup-teardown-decorator.js.map